'From Smalltalk/X, Version:5.2.8 on 14-01-2008 at 02:12:09 PM'                  !

"{ Package: 'SpreadSheet:simekf1' }"

Object subclass:#CellExpression
	instanceVariableNames:'root'
	classVariableNames:''
	poolDictionaries:''
	category:'obp-SpreadSheet'
!

!CellExpression methodsFor:'accessing'!

asString
        ^ self stringRepr.
!

root
        ^ root.
!

value
        | val |
        root isNil ifTrue: [^ CellEmpty new].
        [val := root value.] on: MessageNotUnderstood do: [:ex | ^ CellUndefined new].
        val isNil ifTrue: [^ CellEmpty new].
        ^val.
! !

!CellExpression methodsFor:'creation'!

root: anExpression
        root := anExpression.
! !

!CellExpression methodsFor:'export'!

exportUsing: anExporter
        ^ anExporter exportCellExpression: self.
!

stringRepr
        root isNil ifTrue: [ ^ '' ] ifFalse: [ ^ '=', (root asString) ].
! !

